Pipeline (Apache Tomcat 9.0.68 API Documentation)

Package org.apache.catalina

## Interface Pipeline

- All Superinterfaces:
    `Contained`
  All Known Implementing Classes:
    `StandardPipeline`

      public interface Pipeline
      extends Contained

  Interface describing a collection of Valves that should be executed in sequence when the `invoke()` method is invoked. It is required that a Valve somewhere in the pipeline (usually the last one) must process the request and create the corresponding response, rather than trying to pass the request on.

  There is generally a single Pipeline instance associated with each Container. The container's normal request processing functionality is generally encapsulated in a container-specific Valve, which should always be executed at the end of a pipeline. To facilitate this, the `setBasic()` method is provided to set the Valve instance that will always be executed last. Other Valves will be executed in the order that they were added, before the basic Valve is executed.

  Author:
    Craig R. McClanahan, Peter Donald

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addValve​(Valve valve)` | Add a new Valve to the end of the pipeline associated with this Container.
    `void` | `findNonAsyncValves​(java.util.Set<java.lang.String> result)` | Identifies the Valves, if any, in this Pipeline that do not support async.
    `Valve` | `getBasic()` |
    `Valve` | `getFirst()` |
    `Valve[]` | `getValves()` |
    `boolean` | `isAsyncSupported()` | Returns true if all the valves in this pipeline support async, false otherwise
    `void` | `removeValve​(Valve valve)` | Remove the specified Valve from the pipeline associated with this Container, if it is found; otherwise, do nothing.
    `void` | `setBasic​(Valve valve)` | Set the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any).

    - ### Methods inherited from interface org.apache.catalina.Contained

      `getContainer, setContainer`

- - ### Method Detail

    - #### getBasic

          Valve getBasic()

      Returns:
        the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any).

    - #### setBasic

          void setBasic​(Valve valve)

      Set the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any). Prior to setting the basic Valve, the Valve's `setContainer()` will be called, if it implements `Contained`, with the owning Container as an argument. The method may throw an `IllegalArgumentException` if this Valve chooses not to be associated with this Container, or `IllegalStateException` if it is already associated with a different Container.

      Parameters:
        `valve` - Valve to be distinguished as the basic Valve

    - #### addValve

          void addValve​(Valve valve)

      Add a new Valve to the end of the pipeline associated with this Container. Prior to adding the Valve, the Valve's `setContainer()` method will be called, if it implements `Contained`, with the owning Container as an argument. The method may throw an `IllegalArgumentException` if this Valve chooses not to be associated with this Container, or `IllegalStateException` if it is already associated with a different Container.

      Implementation note: Implementations are expected to trigger the `Container.ADD_VALVE_EVENT` for the associated container if this call is successful.

      Parameters:
        `valve` - Valve to be added
      Throws:
        `java.lang.IllegalArgumentException` - if this Container refused to accept the specified Valve
        `java.lang.IllegalArgumentException` - if the specified Valve refuses to be associated with this Container
        `java.lang.IllegalStateException` - if the specified Valve is already associated with a different Container

    - #### getValves

          Valve[] getValves()

      Returns:
        the set of Valves in the pipeline associated with this Container, including the basic Valve (if any). If there are no such Valves, a zero-length array is returned.

    - #### removeValve

          void removeValve​(Valve valve)

      Remove the specified Valve from the pipeline associated with this Container, if it is found; otherwise, do nothing. If the Valve is found and removed, the Valve's `setContainer(null)` method will be called if it implements `Contained`.

      Implementation note: Implementations are expected to trigger the `Container.REMOVE_VALVE_EVENT` for the associated container if this call is successful.

      Parameters:
        `valve` - Valve to be removed

    - #### getFirst

          Valve getFirst()

      Returns:
        the Valve instance that has been distinguished as the basic Valve for this Pipeline (if any).

    - #### isAsyncSupported

          boolean isAsyncSupported()

      Returns true if all the valves in this pipeline support async, false otherwise
      Returns:
        true if all the valves in this pipeline support async, false otherwise

    - #### findNonAsyncValves

          void findNonAsyncValves​(java.util.Set<java.lang.String> result)

      Identifies the Valves, if any, in this Pipeline that do not support async.
      Parameters:
        `result` - The Set to which the fully qualified class names of each Valve in this Pipeline that does not support async will be added